package AskUser;

use strict;

use Exporter;
our @ISA = qw( Exporter );
our @EXPORT_OK = qw(
   connect_sock
   bindlisten_sock

   get_lines
   put_lines
);

use Socket;
use IO::Handle; # for $fh->flush()

my $sockpath = "/var/run/askuser.sock";
my $sockaddr = sockaddr_un( $sockpath );

sub get_sock()
{
   my $sock;

   socket( $sock, PF_UNIX, SOCK_STREAM, 0 ) or die "Cannot socket(PF_UNIX) - $!";

   return $sock;
}

sub connect_sock()
{
   if ( ! -S $sockpath ) {
      print STDERR "Socket not available\n";
      exit( 1 );
   }

   my $sock = get_sock();
   
   connect( $sock, $sockaddr ) or die "Cannot connect() - $!";

   return $sock;
}

sub bindlisten_sock()
{
   if ( -S $sockpath ) {
      print STDERR "Socket already exists... forcing unlink\n";
      unlink( $sockpath );
   }

   my $sock = get_sock();

   bind( $sock, $sockaddr ) or die "Cannot bind() - $!";

   listen( $sock, 3 ) or die "Cannot listen() - $!";

   return $sock;
}

sub get_lines($)
{
   my ( $fh ) = @_;

   my $ret = "";
   while( <$fh> ) {
      last if( $_ eq "\n" );
      $ret .= $_;
   }

   return undef unless( defined $_ );
   return $ret;
}

sub put_lines($$)
{
   my ( $fh, $lines ) = @_;

   print $fh $lines;
   print $fh "\n";

   $fh->flush();
}

# Keep perl happy; keep Britain tidy
1;
